/*
    Copyright (c) 2010, 2011 aizo ag, Zurich, Switzerland

    Author: Sergey 'Jin' Bostandzhyan <jin@dev.digitalstrom.org>

    This file is part of dS Assistant.

    dS-Assistant is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    dS-Assistant is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

    NOTE: all APIs, especially the JSON API, offered by this application
          are subject to change without further notice.
*/

#ifndef __CONFIG_OPTIONS_H__
#define __CONFIG_OPTIONS_H__

#include <string>
#include "exceptions.h"

namespace dSA
{

class GenericOption
{
public:
    virtual const std::string& getOption() const
    {
        throw _Exception("Requiested invalid option type");
    };

    virtual const int getIntOption() const
    {
        throw _Exception("Requiested invalid option type");
    };

    virtual const bool getBoolOption() const
    {
        throw _Exception("Requiested invalid option type");
    };

    virtual ~GenericOption() {};
};

class Option : public GenericOption
{
public:
    Option(std::string option);
    virtual const std::string& getOption() const;

protected:
    Option() {};
    std::string m_option;
};

class IntOption : public GenericOption
{
public:
    IntOption(int option);
    virtual const int getIntOption() const;

protected:
    IntOption() {};
    int m_option;
};

class BoolOption : public GenericOption
{
public:
    BoolOption(bool option);
    virtual const bool getBoolOption() const;

protected:
    BoolOption() {};
    bool m_option;
};

}; // namespace

#endif//__CONFIG_OPTIONS_H__
